<?php

namespace App\Http\Resources\API;

use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Support\Facades\Storage;

class FileSimpleResource extends BaseResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request): array
    {
        $data =  [
            'id' => $this->id,
            'title' => $this->title,
            'extension' => $this->extension,
            'size' => $this->size,
            'version' => $this->version,
            'created_at' => (string) $this->created_at,

        ];

        if (isset($this->bimFile)) {
            $data['bim_file'] = new BimFileResource($this->bimFile);
        }
        if (isset($this->createdBy)) {
            $data['created_by'] = new UserProfileResource($this->createdBy);
        }
        return $data;
    }
}
