<?php

namespace App\Http\Resources\API;

use App\Models\Menu;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Support\Collection;


class PermissionGroupResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request): array
    {
        return [
            'id' => $this->id,
            'name' => $this->name,
            'permissions' => PermissionResource::collection($this->MeansPermission($this->permissions)),
        ];
    }

    private function MeansPermission(Collection $permissions){
        $menus=Menu::all()->pluck('permission');
        foreach ($permissions as $permission){
            $permission->is_menus=$menus->contains($permission->name)?true:false;
        }
        return $permissions;
    }
}
